<?php

/*------------------------------------------------------------------------
# com_affiliatetracker - Affiliate Tracker for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2019 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.JoomlaThat.com
# Technical Support:	Forum - http://www.JoomlaThat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//new for Joomla 3.0
if(!defined('DS')){
define('DS',DIRECTORY_SEPARATOR);
}

class  plgPayplansAffiliatetracker extends PPPlugins
{

	public function onPayplansSystemStart()
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_affiliatetracker', JPATH_SITE);

		return true;
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{

		if($this->params->get('action') == "subscription"){
			// no need to trigger if previous and current state is same
			if($prev != null && $prev->getStatus() == $new->getStatus()){
				return true;
			}

			$newStatus  = $new->getStatus();

			// if subscription is active
			if($newStatus == PP_SUBSCRIPTION_ACTIVE){

				$data = new stdClass();

				$data->reference_id = $new->getId();
				$data->extended_name = $new->getTitle();
				$data->value = $new->getPrice();
				$data->user_id = $new->getBuyer()->id;

				$data->name = "PayPlans Subscription";
				$data->type = 1;
				// print_r($data);die;
				$this->create_conversion($data);

			}
		}

		return true;
	}

	public function onPayplansInvoiceAfterSave($prev, $new){

		if($this->params->get('action') == "invoice"){

			$newStatus  = $new->getStatus();

			if($newStatus == PP_INVOICE_PAID){

				$data = new stdClass();

				$data->reference_id = $new->getId();
				$data->extended_name = $new->getTitle();
				$data->value = $new->getTotal();
				$data->user_id = $new->getBuyer()->id;

				$data->name = "PayPlans Invoice";
				$data->type = 2;

				$this->create_conversion($data);

			}
		}

		return true;
	}

	/*
	public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller){
		print_r($payment);
		print_r($data);
		die;
		return true;
	}

	public function onPayplansPaymentAfterSave(PayplansPayment $prev=null, PayplansPayment $new=null)
	{
		print_r($payment);
		print_r($data);
		die;
		return true;
	}

	public function onPayplansTransactionBeforeSave($prev, $new){

		//print_r($new);

		$invoice = $new->getInvoice();

		print_r($invoice);

		$data = new stdClass();

		//$data->reference_id = $new->getId();
		//$data->extended_name = $new->getTitle();
		$data->value = $new->getAmount();
		$data->user_id = $new->getBuyer();

		die;
		return true;
	}
	*/

	function create_conversion($data){
		$db = JFactory::getDBO();

		//we check if this particular order had already been tracked
		$query = " SELECT id FROM #__affiliate_tracker_conversions WHERE component = 'com_payplans' AND type = ".$data->type." AND reference_id = ".$data->reference_id;
		$db->setQuery($query);
		$exists = $db->loadResult();

		//if it didn't exist, we attemp to create the conversion
		if(!$exists){

			$user_id = $data->user_id ;

			$conversion_data = array(
									"name" => $data->name,
									"component" => "com_payplans",
									"extended_name" => $data->extended_name ,
									"type" => $data->type,
									"value" => (float)$data->value ,
									"reference_id" => $data->reference_id,
									"approved" => $this->params->get('activation'),
									"atid" => 0
								);
			//print_r($conversion_data);die;

			require_once(JPATH_SITE.DS.'components'.DS.'com_affiliatetracker'.DS.'helpers'.DS.'helpers.php');
			AffiliateHelper::create_conversion($conversion_data, $user_id);
		}
	}

}
