<?php
/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2015 joomlathat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.joomlathat.com
# Technical Support:	Forum - http://www.joomlathat.com/support
-------------------------------------------------------------------------*/
defined( '_JEXEC' ) or die( 'Unauthorized Access' );

// We want to import our app library
ES::import('admin:/includes/apps/apps');

if(!defined('DS')){
    define('DS',DIRECTORY_SEPARATOR);
}

require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');

/**
 * Some application for EasySocial. Take note that all classes must be derived from the `SocialAppItem` class
 *
 * Remember to rename the Textbook to your own element.
 * @since	1.0
 * @author	Author Name <author@email.com>
 */
class SocialUserAppInvoices extends SocialAppItem
{
    /**
     * Class constructor.
     *
     * @since	1.0
     * @access	public
     */
    public function __construct()
    {
        $lang = JFactory::getLanguage();
        $lang->load('com_invoices');

        parent::__construct();
    }

    /**
     * Triggers the preparation of stream.
     *
     * If you need to manipulate the stream object, you may do so in this trigger.
     *
     * @since	1.0
     * @access	public
     * @param	SocialStreamItem	The stream object.
     * @param	bool				Determines if we should respect the privacy
     */
    public function onPrepareStream( SocialStreamItem &$item, $includePrivacy = true )
    {

        // You should be testing for app context
        if( $item->context !== 'invoices' )
        {
            return;
        }
    }

    /**
     * Triggers the preparation of activity logs which appears in the user's activity log.
     *
     * @since	1.0
     * @access	public
     * @param	SocialStreamItem	The stream object.
     * @param	bool				Determines if we should respect the privacy
     */
    public function onPrepareActivityLog( SocialStreamItem &$item, $includePrivacy = true )
    {
    }

    /**
     * Triggers after a like is saved.
     *
     * This trigger is useful when you want to manipulate the likes process.
     *
     * @since	1.0
     * @access	public
     * @param	SocialTableLikes	The likes object.
     *
     * @return	none
     */
    public function onAfterLikeSave( &$likes )
    {
    }

    /**
     * Triggered when a comment save occurs.
     *
     * This trigger is useful when you want to manipulate comments.
     *
     * @since	1.0
     * @access	public
     * @param	SocialTableComments	The comment object
     */
    public function onAfterCommentSave( &$comment )
    {
    }

    /**
     * Renders the notification item that is loaded for the user.
     *
     * This trigger is useful when you want to manipulate the notification item that appears
     * in the notification drop down.
     *
     * @since	1.0
     * @access	public
     * @param	string
     */
    public function onNotificationLoad( $item )
    {
    }

}
