<?php
/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2015 joomlathat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.joomlathat.com
# Technical Support:	Forum - http://www.joomlathat.com/support
-------------------------------------------------------------------------*/
defined( '_JEXEC' ) or die( 'Unauthorized Access' );

if(!defined('DS')){
    define('DS',DIRECTORY_SEPARATOR);
}

require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');

/**
 * Profile Embed view for Textbook app
 *
 * @since	1.0
 * @access	public
 */

class InvoicesViewProfile extends SocialAppsView
{
    /**
     * This method is invoked automatically and must exist on this view.
     *
     * The contents displayed here will be returned via an AJAX call from the system.
     *
     * @since	1.0.0
     * @access	public
     * @param	int		The user id that is currently being viewed.
     * @return 	void
     */

    public function display($userId = NULL, $docType = NULL)
    {

        // We want the user object from EasySocial so we can do funky stuffs.
        $user 	= Foundry::user( $userId );
        $viewer		= JFactory::getUser();

        $uri		= JURI::base();
        $document	= JFactory::getDocument();

        //els CSS i JS
        //$document->addScript('components/com_finances/assets/items.js');

        $paramsInvoices = JComponentHelper::getParams( 'com_invoices' );

        $return = null;

        $limit = 25;

        // Load up the model
        $model = $this->getInvoicesModel();

        //Load up the view
        $view = $this->getInvoicesView();
        $view->_path['template'][1] = JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'views'.DS.'invoices'.DS.'tmpl';

        $items = $model->getData();
        $quotes = $model->getQuotes();

        $pagination = $model->getPagination();

        $view->assignRef('items',		$items);
        $view->assignRef('quotes',		$quotes);

        $view->assignRef('pagination', $pagination);
        $view->assignRef('params', $paramsInvoices);

        $lists['date_in'] = $model->getDateIn();
        $lists['date_out'] = $model->getDateOut();

//        $lists['order']     = $model->getFilterOrder();
//        $lists['order_Dir'] = $model->getFilterOrderDir();

        $view->assignRef( 'lists',	$lists );


        if( $user->isViewer() ){
            echo $view->loadTemplate();
        }

        $params = $this->app->getParams();
        $showGotoMain = $params->get('show_gotomain', 1);

        if ($showGotoMain) {
            echo '
				<div class="gotoMain">
					<a class="btn btn-info" href="'.JRoute::_('index.php?option=com_invoices&view=invoices').'">'.JText::_('GOTO_MAIN').'</a>
				</div>
			';
        }

        echo parent::display('profile/default');
    }

    function getInvoicesModel()
    {
        if (!class_exists( 'InvoicesModelInvoices' ))
        {
            // Build the path to the model based upon a supplied base path
            $path = JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'models'.DS.'invoices.php';
            $false = false;

            // If the model file exists include it and try to instantiate the object
            if (file_exists( $path )) {
                require_once( $path );
                if (!class_exists( 'InvoicesModelInvoices' )) {
                    JError::raiseWarning( 0, 'Model class InvoicesModelInvoices not found in file.' );
                    return $false;
                }
            } else {
                JError::raiseWarning( 0, 'Model InvoicesModelInvoices not supported. File not found.' );
                return $false;
            }
        }

        $model = new InvoicesModelInvoices();
        return $model;
    }

    function getInvoicesView()
    {
        if (!class_exists( 'InvoicesViewInvoices' ))
        {
            // Build the path to the model based upon a supplied base path
            $path = JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'views'.DS.'invoices'.DS.'view.html.php';
            $false = false;

            // If the model file exists include it and try to instantiate the object
            if (file_exists( $path )) {
                require_once( $path );
                if (!class_exists( 'InvoicesViewInvoices' )) {
                    JError::raiseWarning( 0, 'View class InvoicesViewInvoices not found in file.' );
                    return $false;
                }
            } else {
                JError::raiseWarning( 0, 'View InvoicesViewInvoices not supported. File not found.' );
                return $false;
            }
        }

        $view = new InvoicesViewInvoices();
        return $view;
    }
}
